b58e0f02db465a4bca32afe0ba3bee89ec727783
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # The tenth parameter is the version number of the submission, e.g. 1007.
50 LLVM_SUBMIT_VERSION="${10}"
51
52 # The eleventh parameter is the subversion number of the submission, e.g. 03.
53 LLVM_SUBMIT_SUBVERSION="${11}"
54
55 # The current working directory is where the build will happen. It may already
56 # contain a partial result of an interrupted build, in which case this script
57 # will continue where it left off.
58 DIR=`pwd`
59
60 DARWIN_VERS=`uname -r | sed 's/\..*//'`
61 echo DARWIN_VERS = $DARWIN_VERS
62
63 if [ "x$RC_ProjectName" = "xllvmCore_Embedded" ]; then
64     DEST_DIR="$DEST_DIR/Developer/Platforms/iPhoneOS.platform"
65     mkdir -p "$DEST_DIR"
66 fi
67
68 DEVELOPER_DIR="${DEVELOPER_DIR-Developer}"
69 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
70     DT_HOME="$DEST_DIR/usr"
71     HOST_SDKROOT=$SDKROOT
72 else
73     DT_HOME="$DEST_DIR/$DEVELOPER_DIR/usr"
74 fi
75
76 DEST_ROOT="/$DEVELOPER_DIR$DEST_ROOT"
77
78 ################################################################################
79 # Run the build.
80
81 # Create the source tree we'll actually use to build, deleting
82 # tcl since it doesn't actually build properly in a cross environment
83 # and we don't really need it.
84 SRC_DIR=$DIR/src
85 rm -rf $SRC_DIR || exit 1
86 mkdir $SRC_DIR || exit 1
87 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
88 # We can't use the top-level Makefile as-is.  Remove the soft link:
89 rm $SRC_DIR/Makefile || exit 1
90 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
91 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
92
93 # Build the LLVM tree universal.
94 mkdir -p $DIR/obj-llvm || exit 1
95 cd $DIR/obj-llvm || exit 1
96
97
98 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
99   # The cross-tools' build process expects to find an existing cross toolchain
100   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
101   rm -rf $DIR/bin || exit 1
102   mkdir $DIR/bin || exit 1
103   for prog in ar nm ranlib strip lipo ld as ; do
104     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
105     T=`xcrun -sdk $SDKROOT -find ${prog}`
106     echo '#!/bin/sh' > $P || exit 1
107     echo 'exec '$T' "$@"' >> $P || exit 1
108     chmod a+x $P || exit 1
109   done
110   # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
111   for prog in gcc g++ ; do
112     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
113     T=`xcrun -find llvm-${prog}`
114     if [ "x$T" = "x" ] ; then
115       T=`xcrun -sdk $SDKROOT -find ${prog}`
116     fi
117     echo '#!/bin/sh' > $P || exit 1
118     echo 'exec '$T' -arch armv6 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
119     chmod a+x $P || exit 1
120   done
121
122   PATH=$DIR/bin:$PATH
123 # otherwise, try to use llvm-gcc if it's available
124 elif [ $DARWIN_VERS -gt 9 ]; then
125   # If the user has set CC or CXX, respect their wishes.  If not,
126   # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
127   # available, fall back to usual GCC/G++ default.
128   savedPATH=$PATH ; PATH="/Developer/usr/bin:$PATH"
129   XTMPCC=$(which llvm-gcc)
130   if [ x$CC  = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC  ; fi
131   XTMPCC=$(which llvm-g++)
132   if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
133   PATH=$savedPATH
134   unset XTMPCC savedPATH
135 fi
136
137
138 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
139   if [ \! -f Makefile.config ]; then
140       $SRC_DIR/configure --prefix=$DT_HOME \
141           --enable-targets=arm \
142           --host=arm-apple-darwin10 \
143           --target=arm-apple-darwin10 \
144           --build=i686-apple-darwin10 \
145           --enable-assertions=$LLVM_ASSERTIONS \
146           --enable-optimized=$LLVM_OPTIMIZED \
147           --disable-bindings \
148           || exit 1
149   fi
150 else
151   if [ \! -f Makefile.config ]; then
152       $SRC_DIR/configure --prefix=$DT_HOME/local \
153           --enable-targets=arm,x86,powerpc,cbe \
154           --enable-assertions=$LLVM_ASSERTIONS \
155           --enable-optimized=$LLVM_OPTIMIZED \
156           --disable-bindings \
157           || exit 1
158   fi
159 fi
160
161 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
162
163 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
164     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
165     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
166     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
167 fi
168
169 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
170     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
171 else
172     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
173 fi
174
175 GCC_VER=`cc --version 2>/dev/null | sed 1q`
176
177 if echo "$GCC_VER" | grep GCC > /dev/null; then
178     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
179     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
180     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
181 fi
182
183 JOBS_FLAG=""
184
185 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
186 # already has parallelism and we don't want to make the builders hit swap by
187 # firing off too many gccs at the same time.
188 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
189     # Figure out how many make processes to run.
190     SYSCTL=`sysctl -n hw.activecpu`
191
192     # hw.activecpu only available in 10.2.6 and later
193     if [ -z "$SYSCTL" ]; then
194         SYSCTL=`sysctl -n hw.ncpu`
195     fi
196
197     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
198     # Builders can default to 2, since even if they are single processor,
199     # nothing else is running on the machine.
200     if [ -z "$SYSCTL" ]; then
201         SYSCTL=2
202     fi
203
204     JOBS_FLAG="-j $SYSCTL"
205 fi
206
207 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
208     UNIVERSAL_SDK_PATH=$HOST_SDKROOT \
209     NO_RUNTIME_LIBS=1 \
210     DISABLE_EDIS=1 \
211     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
212     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
213     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
214     VERBOSE=1
215
216 if [ $? != 0 ] ; then
217     echo "error: LLVM 'make' failed!"
218     exit 1
219 fi 
220
221 ################################################################################
222 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
223 # $DEST_DIR, with occasional 'lipo' commands.
224
225 cd $DEST_DIR || exit 1
226
227 # Clean out DEST_DIR in case -noclean was passed to buildit.
228 rm -rf * || exit 1
229
230 cd $DIR/obj-llvm || exit 1
231
232 # Install the tree into the destination directory.
233 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
234     NO_RUNTIME_LIBS=1 \
235     DISABLE_EDIS=1 \
236     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
237     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
238     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
239
240 if ! test $? == 0 ; then
241     echo "error: LLVM 'make install' failed!"
242     exit 1
243 fi 
244
245 # Install Version.h
246 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
247 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
248     LLVM_MINOR_VERSION=0
249 fi
250 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
251 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
252 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
253
254 if [ "x$LLVM_DEBUG" != "x1" ]; then
255     # Strip local symbols from llvm libraries.
256     strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
257     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
258         strip -Sx $f
259     done
260 fi
261
262 # Copy over the tblgen utility.
263 cp `find $DIR -name tblgen` $DT_HOME/local/bin
264
265 # Remove .dir files 
266 cd $DEST_DIR$DEST_ROOT
267 rm -f bin/.dir etc/llvm/.dir lib/.dir
268
269 # Remove PPC64 fat slices.
270 cd $DEST_DIR$DEST_ROOT/bin
271 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
272     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
273         -exec lipo -extract ppc -extract i386 {} -output {} \;
274 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
275     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
276         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
277 else
278     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
279         -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
280 fi
281
282 cd $DEST_DIR$DEST_ROOT
283 if [ "$INSTALL_LIBLTO" == yes ]; then
284   mkdir -p $DT_HOME/lib
285   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
286   strip -S $DT_HOME/lib/libLTO.dylib
287 else
288   rm lib/libLTO.dylib
289 fi
290 rm -f lib/libLTO.a lib/libLTO.la
291
292 # The Hello dylib is an example of how to build a pass. No need to install it.
293 rm lib/libLLVMHello.dylib
294
295 # Compress manpages
296 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
297 gzip -f $MDIR/*
298
299 ################################################################################
300 # Create SYM_DIR with information required for debugging.
301
302 # Figure out how many make processes to run.
303 SYSCTL=`sysctl -n hw.activecpu`
304
305 # hw.activecpu only available in 10.2.6 and later
306 if [ -z "$SYSCTL" ]; then
307   SYSCTL=`sysctl -n hw.ncpu`
308 fi
309
310 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
311 # can default to 2, since even if they are single processor, nothing else is
312 # running on the machine.
313 if [ -z "$SYSCTL" ]; then
314   SYSCTL=2
315 fi
316
317 cd $SYM_DIR || exit 1
318
319 # Clean out SYM_DIR in case -noclean was passed to buildit.
320 rm -rf * || exit 1
321
322 # Generate .dSYM files
323 find $DEST_DIR -perm -0111 -type f \
324     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
325     -print | xargs -n 1 -P ${SYSCTL} dsymutil
326
327 # Save .dSYM files and .a archives
328 cd $DEST_DIR || exit 1
329 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
330     | cpio -pdml $SYM_DIR || exit 1
331
332 # Save source files.
333 mkdir $SYM_DIR/src || exit 1
334 cd $DIR || exit 1
335 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
336     | cpio -pdml $SYM_DIR/src || exit 1
337
338 ################################################################################
339 # Remove debugging information from DEST_DIR.
340
341 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
342 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
343 chgrp -h -R wheel $DEST_DIR
344 chgrp -R wheel $DEST_DIR
345
346 ################################################################################
347 # Remove tar ball from docs directory
348
349 find $DEST_DIR -name html.tar.gz -exec rm {} \;
350
351 ################################################################################
352 # symlinks so that B&I can find things
353
354 if [ "$INSTALL_LIBLTO" == yes ]; then
355   mkdir -p $DEST_DIR/usr/lib/
356   cd $DEST_DIR/usr/lib && \
357     ln -s ../../$DEVELOPER_DIR/usr/lib/libLTO.dylib ./libLTO.dylib
358 fi
359
360 ################################################################################
361 # w00t! Done!
362
363 exit 0